# $Id: ModMagic8Ball.pm,v 1.1 2006/12/21 05:00:51 bobzilla Exp $
# Copyright (c) 2003-2004 Robert Hagemann <bobzilla@gothictech.com>
#
# Permission to use, copy, modify, and distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

package ModMagic8Ball;

@ModMagic8Ball::ISA = qw(OmniMod);

use strict;

my $on = 1;

my %shake = (
  "evil" => "shakes the psychic evil sphere...",
  "original" => "shakes the psychic black sphere...",
  "new" => "shakes the psychic plaid sphere...",
  "sarcastic" => "shakes the psychic purple sphere...",
  );

my @answers = (
  "evil, You will die.",
  "evil, In the worst possible way.",
  "original, ask again later.",
  "original, Signs point to yes.",
  "original, Yes.",
  "original, Reply hazy, try again.",
  "original, Without a doubt.",
  "original, My sources say no.",
  "original, As I see it, yes.",
  "original, You may rely on it.",
  "original, Concentrate and ask again.",
  "original, Outlook not so good.",
  "original, It is decidedly so.",
  "original, Better not tell you now.",
  "original, Very doubtful.",
  "original, Yes - definitely.",
  "original, It is certain.",
  "original, Cannot predict now.",
  "original, Most likely.",
  "original, Ask again later.",
  "original, My reply is no.",
  "original, Outlook good.",
  "original, Don't count on it.",
  "new, Yes, in due time.",
  "new, Definitely not.",
  "new, You will have to wait.",
  "new, I have my doubts.",
  "new, Outlook so so.",
  "new, Looks good to me!",
  "new, Who knows?",
  "new, Looking good!",
  "new, Probably.",
  "new, Are you kidding?",
  "new, Go for it!",
  "new, Don't bet on it.",
  "new, Forget about it.",
  "sarcastic, Ask again never",
  "sarcastic, Leave me alone.",
  );

sub help {
  return if ! $on;

  if ( defined wantarray ) { # do we have help?
    return 1;
  }

  my $this = shift;
  my $irc = shift;
  my $nick = shift;
  my $message = shift;

	$irc->notice( $nick, "[divine <question>] find all answers" );
}

sub name() {
  my $this = shift;
  return "8ball";
}

sub handleMessage {
  my $this = shift;
  my $irc = shift;
  my $channel = shift;
  my $nick = shift;
  my $message = shift;
  my $event = shift;

  return if ! $on;

  my $output = &checkAnyMessage( $irc, $nick, $message, $channel, 0 );
	&ModChatLog::saveMessage('omnicron', $output, $channel )
    if defined $output and $output !~ /^\s*$/si;
}

sub handlePrivateMessage {
  my $this = shift;
  my $irc = shift;
  my $nick = shift;
  my $message = shift;
  my $event = shift;

  return if ! $on;

  &checkAnyMessage( $irc, $nick, $message, $nick, 1 );
}

sub checkAnyMessage {
  my $irc = shift;
  my $nick = shift;
  my $message = shift;
  my $sendTo = shift;
  my $isPrivate = shift;

  my $output;

  if ( $message =~ /^\s*divine\s+\S+/si ) {
    my $answer = $answers[rand(@answers)];
    $answer =~ /^(.*?),\s*(.*)$/si;
    my $type = $1;
    $output = $2;

    $irc->me( $sendTo, $shake{ $type } );
  }

  $irc->privmsg( $sendTo, $output ) if defined $output;

  return $output;
}

1;
