#$Id: ModTerror.pm,v 1.5 2006/12/29 15:02:13 uhtu Exp $

# Copyright (c) 2003-2006 Hugh Kennedy <kennedyh@engin.umich.edu>
#
# Permission to use, copy, modify, and distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

package ModTerror;

@ModTerror::ISA = qw(OmniMod);

use LWP::UserAgent;

# mapping levels to colors
my %level = ( 'low'      => 'green',
              'guarded'  => 'blue',
              'elevated' => 'yellow',
              'high'     => 'orange',
              'severe'   => 'red, panic',
              'black'    => 'holy fucking shit');

# the url to pull threat information from
my $URL    = 'http://www.dhs.gov/index.shtm';

# HTTP method to use on $URL
my $method = 'GET';

# seconds to timeout network requests
my $TIMEOUT = 5;

# use actual instance variables
sub new {
  my $proto = shift;
  my $class = ref($proto) || $proto;
  my $self  = $class->SUPER::new();

  my $ua = LWP::UserAgent->new;
  $ua->agent('Mozilla/5.0 (Peace; U; Peace NT 5.0; en-US; rv:0.9.2) Gecko/20010726 Peacezilla6/6.1');
  $ua->timeout( $TIMEOUT );
  $self->{UA} = $ua;

  bless ($self, $class);          # reconsecrate
  return $self;
}


sub name() {
  my $this = shift;
  return "terrorbot";
}

sub help {
  if ( defined wantarray ) { # do we have help?
    return 1;
  }

  my $this = shift;
  my $irc = shift;
  my $nick = shift;
  my $message = shift;

  $irc->notice( $nick, "[threatcon] -> check and report on the current threatcon" );

}

sub handleMessage {
  my $this = shift;
  my $irc = shift;
  my $channel = shift;
  my $nick = shift;
  my $message = shift;

  my $ua = $this->{UA};

  if ( $message =~ m@^(terror|threat|danger)con\??\s*$@i ) {
    $req = new HTTP::Request($method => $URL);
    $res = $ua->request($req);

    if ($res->is_success){
      if ( $res->content =~ /alt="Current national threat level is (\w+)"/i ) {
        $status = $1;
        $status = "$status ($level{$status})" if defined $level{$status};
        $irc->privmsg( $channel, "the current threatcon is: $status" );
      } else {
        $irc->privmsg( $channel, "unable to determine the current threatcon, panic!" );
      }
    } elsif ($res->is_error) {
      $irc->notice( $nick, "error fetching '$URL', PANIC!\n" );
    }
  }
}

sub handlePrivateMessage {
  my ($this, $irc, $nick, $message, $event, $conn ) = @_;
  return handleMessage($this, $irc, $nick, $nick, $message);
}

# return a true value:
'terror is bad';
