# $Id: ModYouTube.pm,v 1.3 2008/07/12 22:38:30 uhtu Exp $
# Copyright (c) 2008 Phil Tom <philtom@gmail.com>
#
# Permission to use, copy, modify, and distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

package ModYouTube;

@ModYouTube::ISA = qw(OmniMod);

use strict;

use URI::Escape;

my $on = 1;
my $ua = LWP::UserAgent->new;
$ua->agent('Mozilla/5.0 (Windows; U; Windows NT 5.0; en-US; rv:0.9.2) Gecko/20010726 Netscape6/6.1');
$ua->timeout(5); # 5s timeout


sub handleMessage {
  my $this = shift;
  my $irc = shift;
  my $channel = shift;
  my $nick = shift;
  my $message = shift;

  return if ! $on;
  return if ! &applicable( $message );

  $irc->privmsg( $channel, &do_yt_search( split /\s+/, $message ) );
}

sub handlePrivateMessage {
  my $this = shift;
  my $irc = shift;
  my $nick = shift;
  my $message = shift;

  return if ! $on;
  return if ! &applicable( $message );

  $irc->notice( $nick, &do_yt_search( split /\s+/, $message ) );
}

sub applicable {
  my $message = shift;
  if ( $message =~ /^yt\s+/ ) {
    return 1;
  }
  return 0;
}

# youtube search 
sub do_yt_search {
  my $url = 'no results';
  my $keywords = '';
  my @words = @_;
 
  splice @words, 0, 1;
  foreach my $word (@words) {
    $keywords = $keywords . $word . '+';
  }
  chop $keywords;
  my $esckeys = uri_escape($keywords);
  my $urlstring = "http://youtube.com/results?search_query=${esckeys}";
  my $request = HTTP::Request->new(GET => $urlstring);
  my $response = $ua->request($request);
  my $html = $response->as_string();
  if ($html =~ /a href=\"([^\"]+)\"\s+title=\"([^\"]+)\"/) {
    $url = "$2 http://youtube.com/$1";
  }
  return $url;
}

sub name() {
  my $this = shift;
  return "youtube";
}

sub help {
  if ( defined wantarray ) { # do we have help?
    return 1;
  }

  my $this = shift;
  my $irc = shift;
  my $nick = shift;
  my $message = shift;

  $irc->notice( $nick, "[yt <search>]  ->  search youtube for <search>" );

}

1;
